#!/bin/sh

start() {
	echo -n "Starting ddns:"
	if [ `/sbin/cfg -a r net.conf DDNS Enable` = 0 ]
	then
		echo disabled
		exit 0
	fi
	/usr/bin/logger -t ipcam "Dynamic DNS register start"
	/usr/sbin/ez-ipupdate -c /etc/ddns.conf 2> /dev/null
	touch /var/lock/subsys/ez-ipupdate
}

stop() {
	/usr/bin/logger -t ipcam "Dynamic DNS register stop"
        /bin/killall -QUIT ez-ipupdate > /dev/null 2>&1
}

restart() {
	stop
	start
}

case "$1" in
	start)
		start
		;;
	stop)
		stop
		;;
	restart)
		restart
		;;
	*)
		echo $"Usage $0 {start|stop|restart}"
		exit 1
esac

exit $?
