#!/bin/sh

primary=`/sbin/cfg -a r net.conf "DNS PROXY" Primary`
secondary=`/sbin/cfg -a r net.conf "DNS PROXY" Secondary`

start() {
	if [ ! -z "$primary" -a ! -z "$secondary" ] ; then
		/usr/sbin/dnrd -s $primary -s $secondary
		retval=$?
	elif [ ! -z "$primary" ] ; then
		/usr/sbin/dnrd -s $primary
		retval=$?
	else
		retval=1
	fi
}

stop() {
	/usr/sbin/dnrd -k > /dev/null 2>&1
}

restart() {
	stop
	start
}

case "$1" in
	start)
		start
		;;
	stop)
		stop
		;;
	restart)
		restart
		;;
	*)
		echo $"Usage $0 {start|stop|restart}"
		exit 1
esac

exit $?
