#!/bin/sh

BONDING=`/sbin/cfg -a r net.conf NETWORK "bonding"`
WFC=/mnt/usb/smrtntky/wsetting.wfc
CMD_POWER_LED_STATE_3=70
CMD_POWER_LED_STATE_4=73

die() {
	echo $@
	exit 1
}

# not wireless device, ignore
[ -z $BONDING ] && die "not wireless device"
[ -f $WFC ] ||  die "no WFC configuration file"

echo -n "Starting WCN:"
/sbin/wcn comp
ret=$?
if [ $ret = 0 ] ; then
	# SAME SETTING
	echo "same setting, checking done"
	# flashing LED to indicate WCN success
	/sbin/sendmsg hwmon ${CMD_POWER_LED_STATE_3} 0 0
elif [ $ret = 1 ] ; then
 	# SYNC: restart WLAN & write device WFC file in flash disk
	/sbin/wcn sync > /dev/null 2>&1
	ret=$?
	if [ $ret = 0 ] ; then
		echo "sync done"
		/sbin/sendmsg hwmon ${CMD_POWER_LED_STATE_3} 0 0
	else
		echo "sync error"
		/sbin/sendmsg hwmon ${CMD_POWER_LED_STATE_4} 0 0
	fi
else
	# ERROR
	echo "checking error"
	/sbin/sendmsg hwmon ${CMD_POWER_LED_STATE_4} 0 0
fi

exit $ret
